org.apache.xalan.xsltc.dom

## Class NthIterator

- java.lang.Object
- - org.apache.xml.dtm.ref.DTMAxisIteratorBase
  - - org.apache.xalan.xsltc.dom.NthIterator

All Implemented Interfaces:
  java.lang.Cloneable, DTMAxisIterator

    public final class NthIterator
    extends DTMAxisIteratorBase

Author:
  Jacek Ambroziak, Morten Jorgensen

### Field Summary

### Fields inherited from interface org.apache.xml.dtm.DTMAxisIterator

`END`

### Constructor Summary

Constructors
Constructor and Description
`NthIterator(DTMAxisIterator source, int n)`

### Method Summary

Methods
`DTMAxisIterator` `cloneIterator()` Returns a deep copy of this iterator.
`int` `getLast()` Returns the position of the last node within the iteration, as defined by XPath.
`int` `getPosition()`
`void` `gotoMark()` Restores the current node remembered by setMark().
`int` `next()` Get the next node in the iteration.
`DTMAxisIterator` `reset()` Resets the iterator to the last start node.
`void` `setMark()` Remembers the current node for the next call to gotoMark().
`void` `setRestartable(boolean isRestartable)` Set if restartable.
`DTMAxisIterator` `setStartNode(int node)` Set start to END should 'close' the iterator, i.e. subsequent call to next() should return END.

### Methods inherited from class org.apache.xml.dtm.ref.DTMAxisIteratorBase

`getAxis, getNodeByPosition, getStartNode, includeSelf, isDocOrdered, isReverse`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### NthIterator

    public NthIterator(DTMAxisIterator source,
               int n)

### Method Detail

#### setRestartable

    public void setRestartable(boolean isRestartable)

Description copied from interface: `DTMAxisIterator`
Set if restartable.

Specified by:
  `setRestartable` in interface `DTMAxisIterator`
Overrides:
  `setRestartable` in class `DTMAxisIteratorBase`

#### cloneIterator

    public DTMAxisIterator cloneIterator()

Description copied from class: `DTMAxisIteratorBase`
Returns a deep copy of this iterator. Cloned iterators may not be restartable. The iterator being cloned may or may not become non-restartable as a side effect of this operation.

Specified by:
  `cloneIterator` in interface `DTMAxisIterator`
Overrides:
  `cloneIterator` in class `DTMAxisIteratorBase`
Returns:
  a deep copy of this iterator.

#### next

    public int next()

Description copied from interface: `DTMAxisIterator`
Get the next node in the iteration.

Returns:
  The next node handle in the iteration, or END.

#### setStartNode

    public DTMAxisIterator setStartNode(int node)

Description copied from interface: `DTMAxisIterator`
Set start to END should 'close' the iterator, i.e. subsequent call to next() should return END.

Parameters:
  `node` - Sets the root of the iteration.
Returns:
  A DTMAxisIterator set to the start of the iteration.

#### reset

    public DTMAxisIterator reset()

Description copied from interface: `DTMAxisIterator`
Resets the iterator to the last start node.

Specified by:
  `reset` in interface `DTMAxisIterator`
Overrides:
  `reset` in class `DTMAxisIteratorBase`
Returns:
  A DTMAxisIterator which has been reset to the start node, which may or may not be the same as this iterator.

#### getLast

    public int getLast()

Description copied from class: `DTMAxisIteratorBase`
Returns the position of the last node within the iteration, as defined by XPath. In a forward iterator, I believe this equals the number of nodes which this iterator will yield. In a reverse iterator, I believe it should return 1 (since the "last" is the first produced.) This may be an expensive operation when called the first time, since it may have to iterate through a large part of the document to produce its answer.

Specified by:
  `getLast` in interface `DTMAxisIterator`
Overrides:
  `getLast` in class `DTMAxisIteratorBase`
Returns:
  The number of nodes in this iterator (forward) or 1 (reverse).

#### getPosition

    public int getPosition()

Specified by:
  `getPosition` in interface `DTMAxisIterator`
Overrides:
  `getPosition` in class `DTMAxisIteratorBase`
Returns:
  The position of the current node within the set, as defined by XPath. Note that this is one-based, not zero-based.

#### setMark

    public void setMark()

Description copied from interface: `DTMAxisIterator`
Remembers the current node for the next call to gotoMark().

#### gotoMark

    public void gotoMark()

Description copied from interface: `DTMAxisIterator`
Restores the current node remembered by setMark().